
      PROGRAM TDSYGV31
*
*       ணࠬ   PDSYGV3
*
      include 'mpif.h'
*  ⠭ - ࠬ  ..
      INTEGER            LWORK, MAXN, LDA, MAXPROCS, NOUT, LIWORK
      DOUBLE PRECISION   ZERO, MONE
      PARAMETER         (LDA = 100, LWORK=5577, MAXN = 100, LIWORK=30,
*      PARAMETER       (LDA = 100, LWORK = -1, MAXN = 100,LIWORK = -1,
     $                   MAXPROCS = 512, NOUT =6, ZERO = 0.0D+0,
     $                   MONE = -1.0D+0 )
      CHARACTER          UPLO
      PARAMETER          ( UPLO = 'U' )
*
*  ६ ..
      INTEGER            CTXT, I, IAM, INFO, MYCOL, MYROW, N, NB, M,
     $                   NPCOL, NPROCS, NPROW, IA, JA, IB, JB, IBTYPE,
     $                   IFAIL
      DOUBLE PRECISION   ABSTOL, VL, VU
*
*  ᨢ ..
      INTEGER            DESCA( 9 ), DESCB( 9 ),
     $                   IWORK( LIWORK )
*     $                   IWORK( 30 )
      DOUBLE PRECISION   A( LDA, LDA ), B( LDA, LDA ), W( MAXN ),
     $                   WORK( LWORK ), WORK1( 5 )
*     $                   WORK( 300 ), WORK1( 5 )
*
* 譨 ணࠬ ..
      EXTERNAL           BLACS_EXIT, BLACS_GET, BLACS_GRIDEXIT,
     $                   BLACS_GRIDINFO, BLACS_GRIDINIT, BLACS_PINFO,
     $                   BLACS_SETUP, DESCINIT, PDMATINIT, PDLAPRNT,
     $                   PDSYGV3
* 
* 믮塞 
*
* ⠭ 
*
      N = 5
      NB = 2
      NPROW = 2
      NPCOL = 2
      IA = 1
      JA = 1
      IB = 1
      JB = 1
      VL = 0.5D0
      VU = 1.5D0
      IBTYPE = 1
      ABSTOL = 0.D0
*
* 樠  BLACS
*
      CALL BLACS_PINFO( IAM, NPROCS )
      IF( ( NPROCS.LT.1 ) ) THEN
         CALL BLACS_SETUP( IAM, NPROW*NPCOL )
      END IF
*
* 樠 ⥪ BLACS'  ⪨ ᮢ
*
      CALL BLACS_GET( -1, 0, CTXT )
      CALL BLACS_GRIDINIT( CTXT, 'R', NPROW, NPCOL )
      CALL BLACS_GRIDINFO( CTXT, NPROW, NPCOL, MYROW, MYCOL )
*
* ᫨      ⥪,
* 室   ணࠬ
*
      IF( MYROW.EQ.-1 ) GO TO 20
*
* 樠 ਯ஢    A  B
*
      CALL DESCINIT( DESCA, N, N, NB, NB, 0, 0, CTXT, LDA, INFO )
      CALL DESCINIT( DESCB, N, N, NB, NB, 0, 0, CTXT, LDA, INFO )
*
* ஥   A  B
*
      CALL PDMATINIT( N, A, IA, JA, DESCA, B, IB, JB, DESCB, INFO )
*
*  室 
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NOUT, FMT = 9992 )
         WRITE( NOUT, FMT = 9998 )N, N, NB, NB
         WRITE( NOUT, FMT = 9997 )NPROW*NPCOL, NPROW, NPCOL
         WRITE( NOUT, FMT = * ) ' 室  '
         WRITE( NOUT, FMT = 9988 ) UPLO
         WRITE( NOUT, FMT = 9991 ) IBTYPE
         WRITE( NOUT, FMT = 9995 ) VL, VU
         WRITE( NOUT, FMT = 9993 ) ABSTOL
         WRITE( NOUT, FMT = * ) '  DESCA'
         WRITE( NOUT, FMT = 9985 )DESCA
         WRITE( NOUT, FMT = * ) '  DESCB'
         WRITE( NOUT, FMT = 9985 )DESCB
         WRITE( NOUT, FMT = * ) '  A'
      END IF
 9985 FORMAT( / 9I5 /)
 9988 FORMAT( / ' UPLO = ', A /)
 9995 FORMAT( / ' VL = ', D20.12, ' VU = ', D20.12 / )
 9993 FORMAT( / ' ABSTOL = ', D20.12 / )
*
      CALL PDLAPRNT( N, N, A, IA, JA, DESCA, 0, 0, 'A', NOUT, WORK1 )
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NOUT, FMT = * ) '  B'
      END IF
      CALL PDLAPRNT( N, N, B, IB, JB, DESCB, 0, 0, 'B', NOUT, WORK1 )
*
* 襭 饭 ஡ ᮡ⢥ 祭
*
      CALL PDSYGV3( IBTYPE, UPLO, N, A, IA, JA, DESCA,
     $              B, IB, JB, DESCB, VL, VU, ABSTOL, M, W,
     $              WORK, LWORK, IWORK, LIWORK, IFAIL, INFO )
*
*  १⮢
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NOUT, FMT = * ) '  '
         WRITE( NOUT, FMT = 9996 )INFO
         WRITE( NOUT, FMT = 9994 ) M
*         WRITE( NOUT, FMT = 9986 )WORK(1), IWORK(1)
         WRITE( NOUT, FMT = * ) ' ᮡ⢥ ᫠'
         DO 10 I = 1, M
            PRINT *, ' W(', I, ')=', W( I ), ';'
   10    CONTINUE
      END IF
*
      CALL BLACS_GRIDEXIT( CTXT )
   20 CONTINUE
*
      CALL BLACS_EXIT( 0 )
*
 9999 FORMAT( 'W=diag([', 4D16.12, //']);' )
*
 9992 FORMAT( / '  ணࠬ PDSYGV3' )
 9998 FORMAT( / ' ᫥ ᮡ⢥ 祭',
     $       '  ࢠ ( VL, VU )'/
     $      '  饭 ஡ ᮡ⢥ 祭 '/
     $      '    A  B,',
     $      '  A  B - ᨬ  ',
     $      I2, '  ', I2,',' /
     $       '      ࠧ  ', I2, '  ', I2, /)

 9997 FORMAT( / '   ', I2, ' ,',
     $       ' ࠧ  ࠧ஬ ', I2, '  ', I2 /)
 9996 FORMAT( / ' 祭 INFO  = ', I6 /)
 9994 FORMAT( / ' M  = ', I3 /)
 9991 FORMAT( / ' IBTYPE  = ', I1 /)
* 9986 FORMAT( / ' WORK(1) =', D16.5, ' IWORK(1) =', I3/)
      STOP
      END
*
      SUBROUTINE PDMATINIT( N, A, IA, JA, DESCA, B, IB, JB, DESCB,
     $                      INFO )
*
* PDMATINIT   ।   A  B   ⪥ ᮢ
*
*  ⠭ - ࠬ ..
      INTEGER            CTXT_
      PARAMETER          ( CTXT_ = 2 )
* ࠬ - ६ ..
      INTEGER            IA, INFO, JA, N
* ࠬ - ᨢ ..
      INTEGER            DESCA( * ), DESCB( * )
      DOUBLE PRECISION   A( * ), B( * )
*  ६
      INTEGER            I, J, MYCOL, MYROW, NPCOL, NPROW
* 譨 ணࠬ
      EXTERNAL           PDELSET
* ७ 㭪樨 ..
      INTRINSIC          DBLE
*     ..
* 믮  ..
*
      INFO = 0
*
      IF( IA.NE.1 ) THEN
         INFO = -3
      ELSE IF( JA.NE.1 ) THEN
         INFO = -4
      END IF
*
      DO 2 J = 1, N
      DO 1 I = 1, N
      CALL PDELSET( A, I, J, DESCA, 0.0D0)
      CALL PDELSET( B, I, J, DESCB, 0.0D0)
    1 CONTINUE
    2 CONTINUE
      DO 3 I = 1, N-1
         J = I+1
         CALL PDELSET( A, I, J, DESCA, 1.0D0)
         CALL PDELSET( B, I, J, DESCB, 1.0D0)
    3 CONTINUE
      J = N
      DO 5 I = 1, N-1
      CALL PDELSET( A, I, J, DESCA, 1.0D0 )
      CALL PDELSET( B, I, J, DESCB, 1.0D0)
    5 CONTINUE
*
      CALL PDELSET( A, 1, 1, DESCA, 10.0D0)
      CALL PDELSET( A, 1, 2, DESCA, 2.0D0)
      CALL PDELSET( A, 1, 3, DESCA, 3.0D0)
      CALL PDELSET( A, 1, 4, DESCA, 1.0D0)
      CALL PDELSET( A, 2, 2, DESCA, 12.0D0)
      CALL PDELSET( A, 2, 4, DESCA, 2.0D0)
      CALL PDELSET( A, 3, 3, DESCA, 11.0D0)
      CALL PDELSET( A, 3, 5, DESCA, -1.0D0)
      CALL PDELSET( A, 4, 4, DESCA, 9.0D0)
      CALL PDELSET( A, 5, 5, DESCA, 15.0D0)
*
      CALL PDELSET( B, 1, 1, DESCB, 12.0D0)
      CALL PDELSET( B, 1, 3, DESCB, -1.0D0)
      CALL PDELSET( B, 1, 4, DESCB, 2.0D0)
      CALL PDELSET( B, 2, 2, DESCB, 14.0D0)
      CALL PDELSET( B, 2, 4, DESCB, -1.0D0)
      CALL PDELSET( B, 3, 3, DESCB, 16.0D0)
      CALL PDELSET( B, 3, 4, DESCB, -1.0D0)
      CALL PDELSET( B, 4, 4, DESCB, 12.0D0)
      CALL PDELSET( B, 4, 5, DESCB, -1.0D0)
      CALL PDELSET( B, 5, 5, DESCB, 11.0D0)
*
      RETURN
*
*     End of PDMATINIT
*
      END
